代码随想录算法训练营第31天|● 455.分发饼干 ● 376. 摆动序列 ● 53. 最大子序和

文章介绍了如何使用贪心策略解决编程问题,如通过排序实现分发饼干的局部最优解,利用数弯计算摆动序列,以及处理最大子数组和时遇到负数的重新计算。这些例子展示了贪心方法在算法中的常见应用。
摘要由CSDN通过智能技术生成

贪心开局:

局部最优堆叠成全局最优--模拟一下 举不出反例就用贪心

455. 分发饼干

排序之后小饼干优先

class Solution:
    def findContentChildren(self, g: List[int], s: List[int]) -> int:
        g.sort()
        s.sort()
        idx=0
        for i in range(len(s)):
            if idx<len(g) and g[idx]<=s[i]:
                idx+=1
        return idx

大饼干满足大孩子

class Solution:
    def findContentChildren(self, g: List[int], s: List[int]) -> int:
        g.sort()
        s.sort()
        idx=len(s)-1
        res=0
        for i in range(len(g)-1,-1,-1):
            if idx>=0 and s[idx]>=g[i]:
                res+=1
                idx-=1
        return res

376. 摆动序列

也不用什么移除,数弯就行,没有就过

class Solution:
    def wiggleMaxLength(self, nums: List[int]) -> int:
        if len(nums)<=1:return len(nums)
        curdiff=0
        prediff=0
        res=1
        for i in range(len(nums)-1):
            curdiff=nums[i+1]-nums[i]
            if curdiff*prediff<=0 and curdiff!=0:
                res+=1
                prediff=curdiff
        return res

53. 最大子数组和

贪心的经典题 遇到负数重新算

属于是见过的套路题就记下来

class Solution:
    def maxSubArray(self, nums: List[int]) -> int:
        res=float('-inf')
        cnt=0
        for i in range(len(nums)):
            cnt+=nums[i]
            if cnt>res:
                res=cnt
            if cnt<=0:#一旦总和为负 就重新来
                cnt=0
        return res

第二十二算法训练营主要涵盖了Leetcode题目中的三道题目,分别是Leetcode 28 "Find the Index of the First Occurrence in a String",Leetcode 977 "有序数组的平方",和Leetcode 209 "长度最小的子数组"。 首先是Leetcode 28题,题目要求在给定的字符串中找到第一个出现的字符的索引。思路是使用双指针来遍历字符串,一个指向字符串的开头,另一个指向字符串的结尾。通过比较两个指针所指向的字符是否相等来判断是否找到了第一个出现的字符。具体实现的代码如下: ```python def findIndex(self, s: str) -> int: left = 0 right = len(s) - 1 while left <= right: if s[left == s[right]: return left left += 1 right -= 1 return -1 ``` 接下来是Leetcode 977题,题目要求对给定的有序数组中的元素进行平方,并按照非递减的顺序返回结果。这里由于数组已经是有序的,所以可以使用双指针的方法来解决问题。一个指针指向数组的开头,另一个指针指向数组的末尾。通过比较两个指针所指向的元素的绝对值的大小来确定哪个元素的平方应该放在结果数组的末尾。具体实现的代码如下: ```python def sortedSquares(self, nums: List[int]) -> List[int]: left = 0 right = len(nums) - 1 ans = [] while left <= right: if abs(nums[left]) >= abs(nums[right]): ans.append(nums[left ** 2) left += 1 else: ans.append(nums[right ** 2) right -= 1 return ans[::-1] ``` 最后是Leetcode 209题,题目要求在给定的数组中找到长度最小的子数组,
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值